package com.mss;

import java.math.BigDecimal;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.*;

import org.json.JSONException;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.View;

import com.paypal.android.sdk.payments.PayPalPayment;
import com.paypal.android.sdk.payments.PayPalService;
import com.paypal.android.sdk.payments.PaymentActivity;
import com.paypal.android.sdk.payments.PaymentConfirmation;

@Version(1.0f)
//@Permissions(values={"android.permission.INTERNET"})
@ShortName("PayPalREST")
@DependsOn(values={"PayPalAndroidSDK"})
// must be set to ActivityObject to get correct version of BA
@ActivityObject


public class PayPalREST {
    // set to PaymentActivity.ENVIRONMENT_PRODUCTION to move real money.
    // set to PaymentActivity.ENVIRONMENT_SANDBOX to use your test credentials from https://developer.paypal.com
    // set to PaymentActivity.ENVIRONMENT_NO_NETWORK to kick the tires without communicating to PayPal's servers.
    public static final String ENVIRONMENT_PRODUCTION = PaymentActivity.ENVIRONMENT_PRODUCTION;
    public static final String ENVIRONMENT_SANDBOX = PaymentActivity.ENVIRONMENT_SANDBOX;
    public static final String ENVIRONMENT_NO_NETWORK = PaymentActivity.ENVIRONMENT_NO_NETWORK;

    // note that these credentials will differ between live & sandbox environments.
    //private static final String CONFIG_CLIENT_ID = "*******yHUEnc5hPI1G_pEE46sBpmbag4338u20IDuGZzzvKuFxfKgeGVF";
    // when testing in sandbox, this is likely the -facilitator email address. 
    //private static final String CONFIG_RECEIVER_EMAIL = "*******-facilitator@yahoo.com";

    private static String TransactionString;
    private static int TransactionResult;

    public static void SetResult(int xResult){
      TransactionResult = xResult;
    }
    public static int GetResult() {
      return TransactionResult;
    }
    public static void SetTransactionString(String xString) {
      TransactionString = xString;
    }
    public static String GetTransactionString() {
      return TransactionString;
    }

    public void Start(final BA pBA, final String xConfig, final String xClientId, final String xReceiverEmail) {
      SetTransactionString("Started");
      Intent intent = new Intent(pBA.context, PaymentActivity.class);
    
      intent.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, xConfig);
      intent.putExtra(PaymentActivity.EXTRA_CLIENT_ID, xClientId);
      intent.putExtra(PaymentActivity.EXTRA_RECEIVER_EMAIL, xReceiverEmail);
    
      pBA.context.startService(intent);
    }
  
    private anywheresoftware.b4a.IOnActivityResult ion;

    public void Buy(final BA pBA, final String xConfig, final String xClientId, final String xReceiverEmail, final String xPayerId, final String xAmount, final String xItem) {
      SetResult(0);
      PayPalPayment thingToBuy = new PayPalPayment(new BigDecimal(xAmount), "USD", xItem);
        
      Intent i = new Intent(pBA.context, PaymentActivity.class);
        
      i.putExtra(PaymentActivity.EXTRA_PAYPAL_ENVIRONMENT, xConfig);
      i.putExtra(PaymentActivity.EXTRA_CLIENT_ID, xClientId);
      i.putExtra(PaymentActivity.EXTRA_RECEIVER_EMAIL, xReceiverEmail);
        
      // It's important to repeat the clientId here so that the SDK has it if Android restarts your 
      // app midway through the payment UI flow.
      i.putExtra(PaymentActivity.EXTRA_CLIENT_ID, xClientId);
      i.putExtra(PaymentActivity.EXTRA_PAYER_ID, xPayerId);
      i.putExtra(PaymentActivity.EXTRA_PAYMENT, thingToBuy);

      ion = new anywheresoftware.b4a.IOnActivityResult() {
        @SuppressWarnings("unchecked")
        @Override
        public void ResultArrived(int resultCode, Intent data) {
          PayPalREST p = new PayPalREST();
          p.SetResult(resultCode);
          if (resultCode == Activity.RESULT_OK) {
            PaymentConfirmation confirm = data.getParcelableExtra(PaymentActivity.EXTRA_RESULT_CONFIRMATION);
            if (confirm != null) {
                try {
                    //Log.i("paymentExample", confirm.toJSONObject().toString(4));
                    p.SetTransactionString(confirm.toJSONObject().toString(4));
                    // TODO: send 'confirm' to your server for verification.
                    // see https://developer.paypal.com/webapps/developer/docs/integration/mobile/verify-mobile-payment/
                    // for more details.

                } catch (JSONException e) {
                    //Log.e("paymentExample", "an extremely unlikely failure occurred: ", e);
                }
            }
          }
          else if (resultCode == Activity.RESULT_CANCELED) {
            //Log.i("paymentExample", "The user cancelled.");
          }
          else if (resultCode == PaymentActivity.RESULT_PAYMENT_INVALID) {
            //Log.i("paymentExample", "An invalid payment was submitted. Please see the docs.");
          }
        }
      };
      pBA.startActivityForResult(ion, i);
    }


}
